var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to2, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to2, key) && key !== except)
        __defProp(to2, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to2;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  startPortal: () => startPortal
});
module.exports = __toCommonJS(src_exports);
var import_as_table = __toESM(require("as-table"));
var import_lodash = __toESM(require("lodash"));
var import_colorette = require("colorette");
var repl = require("repl");
var table = import_as_table.default.configure({
  title: (x) => (0, import_colorette.bold)((0, import_colorette.green)(x)),
  delimiter: (0, import_colorette.gray)(" | "),
  dash: (0, import_colorette.gray)("-")
});
var serialize = (c, serializer) => {
  if (import_lodash.default.isArray(c)) {
    return import_lodash.default.map(c, serializer);
  } else {
    return serializer(c);
  }
};
var to = (c) => console.log(table(serialize(c, (v) => v.toJSON())));
var tr = (c) => console.log(table(serialize(c, (v) => v.get())));
var oo = (c) => console.log(serialize(c, (v) => v.toJSON()));
var ro = (c) => console.log(serialize(c, (v) => v.get()));
var startPortal = (context) => {
  const models = context.models();
  const controllers = context.controllers();
  const environment = context.environment();
  const printRoutes = context.helpers.printRoutes;
  const printJobCounts = context.helpers.printJobCounts;
  const replServer = repl.start({
    prompt: `\u26A1[${(0, import_colorette.bold)((0, import_colorette.green)(environment))}] ${(0, import_colorette.bold)((0, import_colorette.white)(">"))} `
  });
  Object.assign(replServer.context, models);
  Object.assign(replServer.context, { to, tr, oo, ro });
  replServer.defineCommand("jobs", {
    help: "show job counts",
    async action() {
      this.clearBufferedCommand();
      await printJobCounts(context.workers());
      this.displayPrompt();
    }
  });
  replServer.defineCommand("models", {
    help: "show models",
    action() {
      this.clearBufferedCommand();
      console.log(`${Object.keys(models).join("\n")}`);
      this.displayPrompt();
    }
  });
  replServer.defineCommand("routes", {
    help: "show routes",
    action(snippets) {
      this.clearBufferedCommand();
      printRoutes(controllers, snippets ? [snippets] : void 0);
      this.displayPrompt();
    }
  });
  replServer.defineCommand("saybye", function saybye() {
    console.log("Goodbye!");
    this.close();
  });
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  startPortal
});
